> ## Documentation Index
> Fetch the complete documentation index at: https://docs.costgraph.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get workflow run detail

> Returns the run, messages, committed plan, rolling upcoming-step forecast, observations, effects, events, and outcome facts.



## OpenAPI

````yaml /api-reference/costgraph/openapi.json get /api/v1/tenant/automation/runs/{run_id}
openapi: 3.0.0
info:
  description: Read and manage your CostGraph organization, spend, alerts, and settings.
  title: CostGraph API
  contact: {}
  version: '1.0'
servers:
  - url: https://api.costgraph.ai
security: []
tags:
  - name: ai
    x-group: AI
  - name: ai-serving
    x-group: AI serving
  - name: anomalies
    x-group: Anomalies
  - name: auth
    x-group: Auth
  - name: billing
    x-group: Billing
  - name: billing-export
    x-group: Billing export
  - name: budgets
    x-group: Budgets
  - name: ci
    x-group: CI
  - name: compute-recommendations
    x-group: Compute recommendations
  - name: config
    x-group: Config
  - name: cost
    x-group: Cost
  - name: gpus
    x-group: GPUs
  - name: graphai
    x-group: Graph AI
  - name: infracost
    x-group: Infracost
  - name: integrations
    x-group: Integrations
  - name: invitations
    x-group: Invitations
  - name: kubernetes-clusters
    x-group: Kubernetes clusters
  - name: marketplace
    x-group: Marketplace
  - name: network-requests
    x-group: Network requests
  - name: notifications
    x-group: Notifications
  - name: oauth
    x-group: OAuth
  - name: oauth-clients
    x-group: OAuth clients
  - name: opencost
    x-group: OpenCost
  - name: organization
    x-group: Audit log
  - name: organizations
    x-group: Organizations
  - name: placement-alternatives
    x-group: Placement alternatives
  - name: reports
    x-group: Reports
  - name: service-map
    x-group: Service map
  - name: settings
    x-group: Settings
  - name: sso
    x-group: Single sign-on
  - name: tenants
    x-group: Tenants
  - name: user
    x-group: Users
  - name: virtual-machines
    x-group: Virtual machines
  - name: virtual-tags
    x-group: Virtual tags
  - name: workflows
    x-group: Workflows
paths:
  /api/v1/tenant/automation/runs/{run_id}:
    get:
      tags:
        - workflows
      summary: Get workflow run detail
      description: >-
        Returns the run, messages, committed plan, rolling upcoming-step
        forecast, observations, effects, events, and outcome facts.
      parameters:
        - description: Tenant ID
          name: X-CostGraph-Tenant-ID
          in: header
          required: true
          schema:
            type: string
        - description: Run ID
          name: run_id
          in: path
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/responses.SuccessResponse'
                  - type: object
                    properties:
                      data:
                        $ref: '#/components/schemas/automation.RunDetailProjection'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
      security:
        - BearerAuth: []
components:
  schemas:
    responses.SuccessResponse:
      type: object
      required:
        - message
        - status
      properties:
        data: {}
        message:
          type: string
          example: some message
        status:
          type: string
          example: success
    automation.RunDetailProjection:
      type: object
      required:
        - effects
        - events
        - messages
        - observations
        - outcome_facts
        - plan
        - run
        - upcoming_steps
      properties:
        effects:
          type: array
          items:
            $ref: '#/components/schemas/automation.RunEffectProjection'
        events:
          type: array
          items:
            $ref: '#/components/schemas/automation.RunEventProjection'
        failure:
          $ref: '#/components/schemas/automation.RunFailureProjection'
        messages:
          type: array
          items:
            $ref: '#/components/schemas/automation.RunMessageProjection'
        observations:
          type: array
          items:
            $ref: '#/components/schemas/automation.ObservationProjection'
        outcome_facts:
          type: array
          items:
            $ref: '#/components/schemas/automation.OutcomeFactV1'
        plan:
          type: array
          items:
            $ref: '#/components/schemas/automation.PlanNodeProjection'
        run:
          $ref: '#/components/schemas/automation.RunProjection'
        upcoming_steps:
          type: array
          items:
            $ref: '#/components/schemas/automation.UpcomingStepProjection'
    responses.ErrorResponse:
      type: object
      required:
        - message
        - status
      properties:
        message:
          type: string
          example: some message
        status:
          type: string
          example: error
    automation.RunEffectProjection:
      type: object
      required:
        - bundle_status
        - created_at
        - effect_hash
        - effective_risk_tier
        - estimated_cost_cents
        - node_id
        - undo
        - updated_at
      properties:
        bundle_status:
          type: string
        canonical_input:
          type: object
        capability_connection_id:
          type: string
        capability_id:
          type: string
        capability_version:
          type: string
        categories:
          type: array
          items:
            type: string
        completed_at:
          type: string
        connection_id:
          type: string
        created_at:
          type: string
        effect_bundle_id:
          type: string
        effect_hash:
          type: string
        effect_segment_id:
          type: string
        effective_risk_tier:
          type: integer
        effects:
          type: array
          items:
            $ref: '#/components/schemas/automation.EffectPreview'
        estimated_cost_cents:
          type: integer
        execution_status:
          type: string
        financial_impacts:
          type: array
          items:
            $ref: '#/components/schemas/automation.FinancialImpactV1'
        node_id:
          type: string
        observation_id:
          type: string
        preconditions:
          type: array
          items:
            type: object
        recovery:
          type: object
        segment_hash:
          type: string
        segment_position:
          type: integer
        summary:
          type: string
        targets:
          type: array
          items:
            type: object
        undo:
          $ref: '#/components/schemas/automation.EffectUndoAvailabilityV1'
        updated_at:
          type: string
        verification:
          type: object
    automation.RunEventProjection:
      type: object
      required:
        - created_at
        - kind
        - sequence
      properties:
        created_at:
          type: string
        kind:
          type: string
        node_id:
          type: string
        plan_version_id:
          type: string
        sequence:
          type: integer
    automation.RunFailureProjection:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
        message:
          type: string
        remediation:
          type: string
        retryable:
          type: boolean
    automation.RunMessageProjection:
      type: object
      required:
        - content
        - created_at
        - message_id
        - role
      properties:
        content:
          type: string
        created_at:
          type: string
        message_id:
          type: string
        role:
          type: string
          enum:
            - user
            - assistant
        suggested_goal_change:
          type: object
    automation.ObservationProjection:
      type: object
      required:
        - created_at
        - data_classification
        - observation_id
        - payload
        - source_kind
      properties:
        capability_id:
          type: string
        capability_version:
          type: string
        created_at:
          type: string
        data_classification:
          type: string
        node_id:
          type: string
        observation_id:
          type: string
        payload:
          type: object
        source_kind:
          type: string
    automation.OutcomeFactV1:
      type: object
      required:
        - key
        - label
        - value
      properties:
        key:
          type: string
        label:
          type: string
        sourceObservationId:
          type: string
        unit:
          type: string
        value: {}
    automation.PlanNodeProjection:
      type: object
      required:
        - created_at
        - detail
        - kind
        - node_id
        - plan_version
        - plan_version_id
        - state
        - title
      properties:
        capability_id:
          type: string
        capability_version:
          type: string
        created_at:
          type: string
        detail:
          type: object
        kind:
          type: string
        node_id:
          type: string
        plan_version:
          type: integer
        plan_version_id:
          type: string
        state:
          type: string
        title:
          type: string
    automation.RunProjection:
      type: object
      required:
        - active_runtime_used_milliseconds
        - allowed_connection_ids
        - created_at
        - decisions_used
        - goal_id
        - goal_name
        - goal_revision_id
        - max_decisions
        - objective
        - run_id
        - savings
        - status
        - summary
        - trigger
        - updated_at
        - used_connection_ids
      properties:
        active_runtime_used_milliseconds:
          type: integer
        allowed_connection_ids:
          type: array
          items:
            type: string
        continued_from_run_id:
          type: string
        created_at:
          type: string
        decisions_used:
          type: integer
        duration_milliseconds:
          type: integer
        finished_at:
          type: string
        goal_id:
          type: string
        goal_name:
          type: string
        goal_revision_id:
          type: string
        max_active_runtime_seconds:
          type: integer
        max_decisions:
          type: integer
        objective:
          type: string
        outcome:
          type: string
          enum:
            - advanced
            - succeeded
            - no_change
            - blocked
        run_id:
          type: string
        savings:
          type: array
          items:
            $ref: '#/components/schemas/automation.SavingsAggregate'
        started_at:
          type: string
        status:
          type: string
          enum:
            - queued
            - running
            - waiting
            - completed
            - failed
            - cancelled
            - blocked
        summary:
          type: string
        timed_out_at:
          type: string
        trigger:
          type: object
        updated_at:
          type: string
        used_connection_ids:
          type: array
          items:
            type: string
    automation.UpcomingStepProjection:
      type: object
      required:
        - id
        - title
      properties:
        id:
          type: string
        title:
          type: string
    automation.EffectPreview:
      type: object
      required:
        - effect_hash
        - effective_risk_tier
        - estimated_cost_cents
      properties:
        canonical_input:
          type: object
        capability_connection_id:
          type: string
        capability_id:
          type: string
        capability_version:
          type: string
        categories:
          type: array
          items:
            type: string
        connection_id:
          type: string
        effect_bundle_id:
          type: string
        effect_hash:
          type: string
        effect_segment_id:
          type: string
        effective_risk_tier:
          type: integer
        effects:
          type: array
          items:
            $ref: '#/components/schemas/automation.EffectPreview'
        estimated_cost_cents:
          type: integer
        financial_impacts:
          type: array
          items:
            $ref: '#/components/schemas/automation.FinancialImpactV1'
        preconditions:
          type: array
          items:
            type: object
        recovery:
          type: object
        segment_hash:
          type: string
        summary:
          type: string
        targets:
          type: array
          items:
            type: object
        verification:
          type: object
    automation.FinancialImpactV1:
      type: object
      required:
        - asOf
        - basis
        - currency
        - kind
        - sourceObservationId
      properties:
        amountCents:
          type: integer
        asOf:
          type: string
        basis:
          type: string
        confidence:
          type: number
        currency:
          type: string
        kind:
          $ref: '#/components/schemas/automation.FinancialImpactKind'
        monthlyCents:
          type: integer
        sourceObservationId:
          type: string
        sourceRecommendationId:
          type: string
    automation.EffectUndoAvailabilityV1:
      type: object
      required:
        - available
      properties:
        available:
          type: boolean
        compensator_version:
          type: string
        unavailable_reason:
          type: string
    automation.SavingsAggregate:
      type: object
      required:
        - active_estimated_monthly_cents
        - currency
        - estimated_accrued_savings_cents
        - pending_projected_monthly_cents
      properties:
        active_estimated_monthly_cents:
          type: integer
        currency:
          type: string
        estimated_accrued_savings_cents:
          type: integer
        pending_projected_monthly_cents:
          type: integer
    automation.FinancialImpactKind:
      type: string
      enum:
        - recurring_savings
        - one_time_savings
        - cost_increase
        - unknown
      x-enum-varnames:
        - FinancialImpactRecurringSavings
        - FinancialImpactOneTimeSavings
        - FinancialImpactCostIncrease
        - FinancialImpactUnknown
  securitySchemes:
    BearerAuth:
      description: Enter "Bearer {token}"
      type: apiKey
      name: Authorization
      in: header

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.